var ChartLabels = [];
var ChartValues = [];
var ChartColors = [];

$(document).ready(Init);

function Init(){
  LoadChart();
  DrawChart();
}

function LoadChart(){
  $('.chart-part').each(function(){
    ChartLabels.push($(this).data('label'));
    ChartValues.push($(this).data('value'));
    ChartColors.push($(this).data('color'));
  })
}

function DrawChart(){
  if(ChartLabels.length==0){return;}
  var ctx = $('#chart')[0].getContext('2d');
  var chart = new Chart(ctx,{
    type:'doughnut',
    data:{
      labels:ChartLabels,
      datasets:[{
        data:ChartValues,
        backgroundColor:ChartColors
      }]
    },
    options: {
      responsive:false,
      plugins:{
        legend:{
          position:'right',
          align:'middle',
          labels:{
            color:'#00296B',
            font:{
              size:16
            }
          }
        },
        tooltip:{
          callbacks:{
            label: ({ label, formattedValue }) => FormatPriceRound(parseInt(formattedValue.replace(/\s/g,'')))+' $'
          }
        }
      },
      elements:{
        arc:{
          borderColor:'#00296B',
        }
      }
    }
  });
}