var events = {
  '03-01':BitcoinGenesis,
  '10-01':EtfApproval,
  '22-05':PizzaDay,
  '9-6':ElSalvador,
  '30-7':EthereumGenesis,
  '15-09':TheMerge,
};
var _var = {};

$(document).ready(Init);

function Init(){
  let currentDate = new Date();
  let key = currentDate.getDate()+'-'+(currentDate.getMonth()+1);
  if(key in events){
    $('#event').removeClass('not-displayed');
    events[key]();
  }
}

//------------------------//
// 2022-09-15 : The Merge //
//------------------------//

function TheMerge(){
  _var.audio = null;
  fetch('/static/fiesta.txt').then(response => {
    if(response.ok){
      response.text().then(text => {
        _var.audio = new Audio();
        _var.audio.src = text;
      });
    }
  });
  let panda = jQuery('<img>',{
    src:'/static/img/events/panda.png',
    title:'The Merge (2022-09-15)'
  });
  $('#event').append(panda);
  $(panda).on('click',Fiesta);
}

function Fiesta(){
  _var.audio.play();
}

//-------------------------------//
// 2021-06-09 : Bitcoin Adoption //
//-------------------------------//

function ElSalvador(){
  let bukele = jQuery('<img>',{
    src:'/static/img/events/nayib_bukele.png',
    title:'Bitcoin Adoption (2021-06-09)'
  });
  $('#event').append(bukele);
  $(bukele).on('click',LaserEyes);
}

function LaserEyes(){
  $('#event>img').attr('src','/static/img/events/nayib_bukele_laser.png');
}

//------------------------//
// 2010-05-22 : Pizza Day //
//------------------------//

function PizzaDay(){
  _var.Hungry = 2;
  OrderPizza();
}

function OrderPizza(){
  _var.Angle = 0;
  _var.vAngle = 5;
  let pizza = jQuery('<img>',{
    src:'/static/img/events/pizza.png',
    title:'Pizza Day (2010-05-22)'
  });
  $('#event').append(pizza);
  pizza.on('load',function(){
    _var.Width = pizza.width();
    _var.Height = pizza.height();
    $(pizza).on('click',function(){Eat(this);});
  });
}

function Eat(pizza){
  $(pizza).css({
    'display':'none',
    'max-width':'initial',
    'max-height':'initial',
    'position':'fixed',
    'z-index':'2010'
  });
  setTimeout(function(){Bite(pizza);},30);
}

function Bite(pizza){
  _var.Width *= 1.04;
  _var.Height *= 1.04;
  _var.Angle += _var.vAngle;
  _var.vAngle += 0.3;
  $(pizza).css({
    'width':_var.Width+'px',
    'height':_var.Height+'px',
    'transform':'rotate('+_var.Angle+'deg)',
    'left':($(window).width()-_var.Width)/2+'px',
    'top':($(window).height()-_var.Height)/2+'px',
    'display':'initial'
  });
  if(Math.min(_var.Height,_var.Width)>8*Math.max($(window).height(),$(window).width())){
    pizza.remove();
    Burp();
  }
  else{
    setTimeout(function(){Bite(pizza);},30);
  }
}

function Burp(){
  _var.Hungry -= 1;
  if(_var.Hungry>0){
    OrderPizza();
  }
  else{
    $('#event').remove();
  }
}

//-----------------------------------//
// 2024-01-10 : Bitcoin ETF approval //
//-----------------------------------//

function EtfApproval(){
  let gary = jQuery('<img>',{
    src:'/static/img/events/gary_gensler.png',
    title:'Bitcoin ETF approval (2024-01-10)'
  });
  $('#event').append(gary);
  $(gary).on('click',ApproveETF);
}

function ApproveETF(){
  let ETF = jQuery('<img>',{
    src:'/static/img/events/approved.png',
    style:'position:absolute; max-width:200px;'
  });
  $('body').append(ETF);
  ETF.on('load',function(){
    let SEC_twitter_hacked_X = RandomFloat(0,$(window).width()-ETF.width());
    let SEC_twitter_hacked_Y = $(window).scrollTop()+RandomFloat(0,$(window).height()-ETF.height());
    ETF.css('left',SEC_twitter_hacked_X+'px');
    ETF.css('top',SEC_twitter_hacked_Y+'px');
  });
}

//------------------------------------//
// 2015-07-30 : Ethereum Genesis Bloc //
//------------------------------------//

function EthereumGenesis(){
  _var.Mempool = [];
  let vitalik = jQuery('<img>',{
    src:'/static/img/events/vitalik_buterin.png',
    title:'Ethereum Genesis Bloc (2015-07-30)'
  });
  $('#event').append(vitalik);
  vitalik.on('load',function(){
    _var.GenesisX = vitalik.offset().left+vitalik.width()/2-15;
    _var.GenesisY = vitalik.offset().top-$(window).scrollTop()+vitalik.height()/2-15;
    $(vitalik).on('click',function(){for(let i=0;i<10;i++){MintETH();}});
    setInterval(TransactionEVM,15);
  });
}

function MintETH(){
  let ETH = {};
  ETH.x = _var.GenesisX;
  ETH.y = _var.GenesisY;
  ETH.vx = RandomFloat(3,13);
  ETH.vy = RandomFloat(-7,1);
  let coin = jQuery('<img>',{
    src:'/static/img/events/ethereum.png',
    style:'position:fixed; left:'+ETH.x+'px; top:'+ETH.y+'px; width:30px; height:30px;'
  });
  ETH.coin = coin;
  $('body').append(coin);
  _var.Mempool.push(ETH);
}

function TransactionEVM(){
  _var.Mempool.forEach(function(ETH){
    ETH.y += ETH.vy;
    if(ETH.y>=window.innerHeight){
      ETH.coin.remove();
    }
    ETH.vy += 0.49;
    ETH.x += ETH.vx;
  });
  _var.Mempool = _var.Mempool.filter(function(ETH){
    return ETH.y<window.innerHeight;
  });
  _var.Mempool.forEach(function(ETH){
    ETH.coin.css('left',ETH.x+'px');
    ETH.coin.css('top',ETH.y+'px');
  });
}

//-----------------------------------//
// 2009-01-03 : Bitcoin Genesis Bloc //
//------------------ ----------------//

function BitcoinGenesis(){
  _var.Mempool = [];
  let satoshi = jQuery('<img>',{
    src:'/static/img/events/satoshi_nakamoto.jpg',
    title:'Bitcoin Genesis Bloc (2009-01-03)'
  });
  $('#event').append(satoshi);
  satoshi.on('load',function(){
    _var.GenesisX = satoshi.offset().left+satoshi.width()/2-15;
    _var.GenesisY = satoshi.offset().top-$(window).scrollTop()+satoshi.height()/2-15;
    $(satoshi).on('click',function(){for(let i=0;i<10;i++){MintBTC();}});
    setInterval(TransactionUTXO,15);
  });
}

function MintBTC(){
  let BTC = {};
  BTC.x = _var.GenesisX;
  BTC.y = _var.GenesisY;
  BTC.vx = RandomFloat(3,13);
  BTC.vy = RandomFloat(-7,1);
  let coin = jQuery('<img>',{
    src:'/static/img/events/bitcoin.png',
    style:'position:fixed; left:'+BTC.x+'px; top:'+BTC.y+'px; width:30px; height:30px;'
  });
  BTC.coin = coin;
  $('body').append(coin);
  _var.Mempool.push(BTC);
}

function TransactionUTXO(){
  _var.Mempool.forEach(function(BTC){
    BTC.y += BTC.vy;
    if(BTC.y>=window.innerHeight){
      BTC.coin.remove();
    }
    BTC.vy += 0.49;
    BTC.x += BTC.vx;
  });
  _var.Mempool = _var.Mempool.filter(function(BTC){
    return BTC.y<window.innerHeight;
  });
  _var.Mempool.forEach(function(BTC){
    BTC.coin.css('left',BTC.x+'px');
    BTC.coin.css('top',BTC.y+'px');
  });
}