var CustodyType = 0;
var NextUpdateType = 0;
var CustodyTypes = {0:'self-custody' , 1:'third-party'};
var NextUpdateTypes = {0:'reference' , 1:'custom'};
var iComponent = 0;

$(document).ready(Init);

function Init(){
  CustodyType = parseInt($('#custody_type').val());
  NextUpdateType = parseInt($('#next_update_type').val());
  AdjustFields();
  StopEvent('.custody-button');
  $('.custody-button').on('click',ToggleCustody);
  StopEvent('.next-update-button');
  $('.next-update-button').on('click',ToggleNextUpdate);
  $('#tags span').each(function(){ClickableTag(this);});
  StopEvent('#add-component');
  $('#add-component').on('click',AddComponent);
  iComponent = $('.component').length;
  for(let i=0;i<iComponent;i++){
    BindDelete(i);
  }
  FillTagsInForm();
}

function BindDelete(i){
  $('#component-'+i+' img').on('click',function(){$(this).closest('.component').remove();});
}

function AddComponent(){
  let symbols = $('#symbols').html();
  let component = '<div id="component-'+iComponent+'" class="component">';
  component += '<select name="token-'+iComponent+'" required>'+symbols+'</select>';
  component += '<input name="balance-'+iComponent+'" class="balance" type="text" placeholder="balance" pattern="^-?\\d*\\.?\\d+$" autocomplete="off" required>';
  component += '<input name="apr-'+iComponent+'" class="apr" type="text" placeholder="APR" pattern="^-?\\d*\\.?\\d+$" autocomplete="off" required>';
  component += '<img src="/static/img/delete.png" title="Delete" alt="DELETE">';
  component += '</div>';
  $('#components').append(component);
  BindDelete(iComponent);
  iComponent += 1;
}

function AdjustFields(){
  $('.'+CustodyTypes[CustodyType]+' select').prop('required',true);
  $('.'+CustodyTypes[1-CustodyType]+' select').prop('required',false);
  $('.'+CustodyTypes[CustodyType]).removeClass('not-displayed');
  $('.'+CustodyTypes[1-CustodyType]).addClass('not-displayed');
  $('#'+NextUpdateTypes[NextUpdateType]).removeClass('not-displayed');
  $('#'+NextUpdateTypes[1-NextUpdateType]).addClass('not-displayed');
}

function ToggleCustody(){
  CustodyType = 1-CustodyType;
  $('#custody_type').val(CustodyType);
  AdjustFields();
}

function ToggleNextUpdate(){
  NextUpdateType = 1-NextUpdateType;
  $('#next_update_type').val(NextUpdateType);
  AdjustFields();
}

function ClickableTag(tag){
  $(tag).on('click',function(){ToggleTag(tag);})
}

function ToggleTag(tag){
  $(tag).toggleClass('selected');
  FillTagsInForm();
}

function FillTagsInForm(){
  $('#tags').val($('#tags span.selected').map(function(){return $(this).data('id');}).get().join('-'));
}