var Data = null;
var SmallVariation = null;
var BigVariation = null;
var SortVariation = false;
var SortDirection = 1;
var Updated = false;

$(document).ready(Init);

function Init(){
  GetTokenInfo();
  $('#update').on('click',Update);
}

function GetTokenInfo(){
  $.ajax({
    url: '/ajax-update-prices-before',
    success: function(response){
      Process(response);
    }
  });
}

function Update(){
  $('#update').remove();
  $.ajax({
    url: '/ajax-update-prices-after',
    success: function(response){
      Updated = true;
      Process(response);
    }
  });
}

function Process(raw_data){
  Data = Object.values(raw_data.tokens);
  if (Updated){
    BigVariation = raw_data.big_variation;
    SmallVariation = raw_data.small_variation;
  }
  Display();
}

function Compare(a,b){
  if (a.last_update==null && b.last_update!=null){
    return -1;
  }
  if (a.last_update!=null && b.last_update==null){
    return 1;
  }
  if (SortVariation){
    if (a.variation>b.variation) return SortDirection;
    if (a.variation<b.variation) return -SortDirection;
    if (a.symbol>b.symbol) return 1;
    return -1;
  }
  if (a.symbol>b.symbol) return SortDirection;
  return -SortDirection;
}

function Display(){
  $('thead tr').remove();
  $('tbody tr').remove();
  let bs = '<button id="button-symbol-down">A</button><button id="button-symbol-up">Z</button>';
  if (Updated){
    let bv = '<button id="button-variation-down">&nbsp;</button><button id="button-variation-up">&nbsp;</button>';
    $('thead').append('<tr><th>'+bs+'Symbol</th><th>Name</th><th>Old price</th><th>New price</th><th>'+bv+'Variation</th></tr>');
    $('#button-variation-down').on('click',function(){SortVariation=true; SortDirection=1; Display();});
    $('#button-variation-up').on('click',function(){SortVariation=true; SortDirection=-1; Display();});
  }
  else{
    $('thead').append('<tr><th>'+bs+'Symbol</th><th>Name</th><th>Price</th><th>Last update</th></tr>');
  }
  $('#button-symbol-down').on('click',function(){SortVariation=false; SortDirection=1; Display();});
  $('#button-symbol-up').on('click',function(){SortVariation=false; SortDirection=-1; Display();});
  Data.sort(Compare);
  let tbody = $('tbody');
  for (let token of Data){
    let cell_1 = (token.slug_link!=null) ? '<td><a href="'+token.slug_link+'">'+token.symbol+'</a></td>' : '<td>'+token.symbol+'</td>';
    let cell_2 = '<td>'+token.name+'</td>';
    let cell_3 = '<td>'+FormatPrice(token.price)+' $</td>';
    if (Updated){
      if (token.last_update!=null){
        let cell_45 = '<td colspan="2" class="mini">LAST UPDATE<br>'+token.last_update+'</td>';
        tbody.append('<tr class="no-update">'+cell_1+cell_2+cell_3+cell_45+'</tr>');
      }
      else{
        let cell_4 = '<td>'+FormatPrice(token.new_price)+' $</td>';
        let row_class;
        let arrow;
        if (token.variation<=-BigVariation){
          arrow='&darr;';
          row_class = 'var-big-down';
        }
        else if (token.variation<=-SmallVariation){
          arrow='&darr;';
          row_class = 'var-small-down';
        }
        else if (token.variation>=BigVariation){
          arrow='&uarr;';
          row_class = 'var-big-up';
        }
        else if (token.variation>=SmallVariation){
          arrow='&uarr;';
          row_class = 'var-small-up';
        }
        else if (token.variation>=0){
          arrow='&uarr;';
          row_class = 'var-stable';
        }
        else{
          arrow='&darr;';
          row_class = 'var-stable';
        }
        let cell_5 = '<td>'+arrow+' '+Math.abs(token.variation).toFixed(1)+' %</td>';
        tbody.append('<tr class="'+row_class+'">'+cell_1+cell_2+cell_3+cell_4+cell_5+'</tr>');
      }
    }
    else {
      let cell_4 = '<td>'+token.last_update+'</td>';
      tbody.append('<tr class="no-update">'+cell_1+cell_2+cell_3+cell_4+'</tr>');
    }
  }
}